package com.jah0wl.catan;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.Vector;
import java.lang.IllegalStateException;

public class Catan extends MIDlet implements CommandListener, Runnable {

    public Display  display;

    //private InicioCanvas cvInicio;
    private PlayersCanvas cvPlayers;
    private ProgressCanvas cvProgress;
    private BoardCanvas cvBoard;

//    public Command  exitCommand = new Command("Salir", Command.EXIT, 20 );
    public Command  exitCommand = new Command("Exit", Command.EXIT, 20 );
    public Command  okCommand = new Command("OK", Command.OK, 1 );

    private Thread threadTablero;

    private Vector jugadores;

    public Catan(){
        display = Display.getDisplay( this );
        jugadores = new Vector();

        cvPlayers = new PlayersCanvas(this);
        try{
            cvPlayers.addCommand(exitCommand);
            cvPlayers.addCommand(okCommand);
            cvPlayers.setCommandListener(this);
        }catch (IllegalStateException e){}
    }

    protected void startApp(){
        display.setCurrent( cvPlayers );
    }

    public void run(){
        cvBoard = new BoardCanvas( this , jugadores );
        display.setCurrent(cvBoard);
        cvProgress=null;
    }

    protected void pauseApp(){
    }

    protected void destroyApp( boolean unconditional ){
    }

    public void exit(){
        destroyApp( true );
        notifyDestroyed();
    }

    public void commandAction( Command c, Displayable d ){
        if( c == exitCommand ){
            exit();
        }else if (c == okCommand && d == cvPlayers){
            // han dice a ok en la eleccion de players
// has given to ok in the election of players
            int jNum;
            if ((jNum = cvPlayers.getNumJugadores())<2)
                cvPlayers.showErrorNumJugadores();
            else{
                // cogemos los colores que van a jugar y creamos los players
                // we take the colors that are going to play and created players
                for (int i=0;i<4;i++){
                    int[] color = new int[3];
                    if ((color = cvPlayers.getColorJugador(i))!=null){
                        jugadores.addElement(new Player(color));
                    }
                }
                genCvTablero();
            }
        }
    }

    public void genCvTablero(){
        cvProgress = new ProgressCanvas();
        try{
            cvProgress.addCommand(exitCommand);
            cvProgress.setCommandListener(this);
        }catch (IllegalStateException e){}
        display.setCurrent(cvProgress);
        cvPlayers =null;
        threadTablero = new Thread(this);
        threadTablero.start();
    }
}
