package com.jah0wl.catan.fields;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import java.io.IOException;
import com.jah0wl.utils.Point;

public class Water extends Field
{
	private int port;
	private int position;
	
	public static final String[] ports =
		{"lumber","sheep","grain","brick","stone","interrogacion"};
//		{"bosque","oveja","trigo","ladrillo","piedra","interrogacion"};
// {forest, ewe, wheat, brick, stone, interrogation};
    private static Image portImage =null;
	
	// Constructor
	public Water(Point p, int r){
		this(p.x,p.y,r,-1,-1);
	}
	public Water(int x, int y, int r){
		this(x,y,r,-1,-1);
	}	
	public Water(int x, int y, int r, int p, int pos){
		super(x,y,r);
		setPort(p,pos);
		if (portImage ==null)
			try{
				portImage = Image.createImage("/ports.png");
			}catch (IOException e){}
	}
	
	// Observadoras selectoras
	public int getPort(){
		return port;
	}
	
	public int getPosition(){
		return position;
	}
	
	public void setPort(int p, int pos){
		port = p;
		position = pos;
	}
		
	public void paint(Graphics g){
		int width = g.getClipWidth();
		int height = g.getClipHeight();
		g.setClip(x-(17/2),y-(13/2),17,13);
		g.drawImage(fieldImage,x-(17/2)-(7*17),y-(13/2),g.TOP|g.LEFT);
		if (port !=-1){
			g.setColor(255,255,255);
			Point p=new Point(getPoint(position));
			Point p2=new Point(getPoint((position +1)%6));
			g.drawLine(x,y,p.x,p.y);
			g.drawLine(x,y,p2.x,p2.y);
			
			g.setClip(x-(7/2),y-(9/2),7,9);
			g.drawImage(portImage,x-(7/2)-(port *7),y-(9/2),g.TOP|g.LEFT);
		}
		g.setClip(0,0,width,height);		
	}
}
